﻿--По умолчанию "глобально" устанавливаем кодировку для всех функций сохранения файлов - UTF8
o = {}; o.File_Encoding = feUTF8; Settings(o)
os.setlocale('', 'ctype')	-- принудительно местная локаль
local a_buf = 3 -- Размер БУФЕРЕА(количество аудиофайлов) готовых к последовательному воспроизведению. Чем БОЛЬШЕ количество, тем "дольше" при старте повышенная нагрузка на ЦП. Чем меньше, тем "больше" вероятность возникновения пауз между блоками. По достижении предела буфера, нагрузка на ЦП становится равномерной.
local simvol_limit = 500 -- минимальное количество символов в выделяемом участке текста при чтении. Чем меньше, тем выше веротяность возникновения пауз между читаемыми блоками.
local abzac = true -- (=true): текст выделяется до конца текущего АБЗАЦА. (=false): текст выделяется до конца текущего ПРЕДЛОЖЕНИЯ 
local sim_book = 1800 -- Коэфициент разбития книги на страницы. Условно среднее количество символов =1800 на одной странице печатного экземпляра книги. 

require "profiles/mylib_index" -- подгружаем личную библиотеку с функциями





--o = {}
--o.Notes_Auto = true -- вставка примечаний
--Settings(o)
FonemInOneFile = true
startnum=0
--local txt_start = 'start.lst'
local txt_end = 'end.lst'
local k=1
local f_sch=0
local b0=0
local b1=0

if not IsFolder(HomeFolder('temp')) then -- проверка на наличие папки для временных файлов
ShowMessage("Не найден путь:\n\n"..HomeFolder('temp').."\n\nСоздайте папку \\temp и запустите скрипт заново.")
end

ind=WActive()
WActive(ind,false)

--ПРОВЕРКА ТЕКСТА
s=WText(ind)
if #s == 0 then 
ShowMessage("Пустой текст!")
goto HALT
end
namebook = WName(ind)
namebook = SplitFileName(namebook)[2]..SplitFileName(namebook)[3] -- ([1]-путь [2]-имя [3]-расширение
if #namebook == 0 then 
ShowMessage("Файл без названия. Сохраните книгу!")
goto HALT
end

fnd, k = RexMatch(namebook,"[[]|[]]",1)
if k > 0 then 
ShowMessage("Недопустимые символы в названии файла:\n[] квадратные скобки")--
goto HALT
end

if FileExists(HomeFolder('profiles')..'read_history.txt') then
 --Продолжить чтение
namebook = WName(ind)
namebook = SplitFileName(namebook)[2]..SplitFileName(namebook)[3] -- ([1]-путь [2]-имя [3]-расширение
if #namebook == 0 then 
ShowMessage("Файл без названия. Сохраните книгу!")
goto HALT
end

WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s = WText(-1)
r=[[>]]..namebook..[[>*>]]
k=1

fnd,k = DicMatch(s,r,k) 
--ShowMessage(fnd)

if #fnd==0 then
start_k=WSel(ind) -- получаем координаты курсора
if start_k==0 then start_k = 1 end
--Запишем в историю координаты курсора
WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s_h = WText(-1)
s_h = s_h..'>'..namebook..'>'..start_k..'>'
WNew(-1,s_h)
WSave(-1,HomeFolder('profiles')..'read_history.txt')
WNew(-1)
end

if #fnd>0 then
start_k=RexMatch(fnd,[[>\d+>]],1)
start_k=LuaRepl(start_k,{'>='})
start_k=tonumber(start_k)



::DDD::
shapka = "ПРОДОЛЖИТЬ ЧТЕНИЕ"
items = {
"С ТЕКУЩЕЙ ПОЗИЦИИ КУРСОРА",
"С СОХРАНЁННОЙ ТОЧКИ ПРЕРВАННОГО ЧТЕНИЯ"
}

dialog = Menu(shapka,items,1,400)
	
	
	if dialog == 0 then goto DDD end




if dialog == 1 then  
start_k=WSel(ind) -- получаем координаты курсора
if start_k==0 then start_k = 1 end
WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s_h = WText(-1)
s_h = s_h..'>'..namebook..'>'..start_k..'>' -- начало книги
WSave(-1,HomeFolder('profiles')..'read_history.txt')
WNew(-1)
end --с начала книги




end

else --Если файла не было (удален)
SaveToFile({""},HomeFolder('profiles')..'read_history.txt') -- создаем файл
--Запишем в историю координаты курсора
start_k=WSel(ind) -- получаем координаты курсора
if start_k==0 then start_k = 1 end
WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s_h = WText(-1)
s_h = s_h..'>'..namebook..'>'..start_k..'>' -- начало книги
WSave(-1,HomeFolder('profiles')..'read_history.txt')
WNew(-1)
end--if FileExists(HomeFolder('profiles')..'read.txt') then


s=WText(ind)
--s:gsub("(%s+)$", "")--удалить пустые строки в конце документа
blok=string.sub(s,start_k,#s)
blok = Fragments(blok,simvol_limit-2,abzac)--???? -2


WSel(ind,start_k,#s) --"ФИКТИВНОЕ" выделение текста до конца страницы для поднятия выделения текста к началу экрана
WSel(ind,start_k,#blok[1]) -- сразу выделим текст
b0=start_k; --получаем координаты для переменной s исходя из длины блоков


--для первой строки сразу:
--ЗАПОМИНАНИЕ ИСТОРИИ
WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s_h = WText(-1)
s_h = RexRepl(s_h,{[[>]]..namebook..[[>\d+>=]]})--удаляем историю
s_h = s_h..'>'..namebook..'>'..b0..'>' -- записываем новую
s_h = RexRepl(s_h,{[[[\r\n]+=\r]]})
WNew(-1,s_h)
WSave(-1,HomeFolder('profiles')..'read_history.txt')


--ЧИСТИМ ПАПКУ temp 
a = AllFiles(HomeFolder('temp'),'*.*')
for i = 1,#a do
os.remove(HomeFolder('temp')..a[i])
end

--Создаем сериал 
startnum=1
for i = 1,#blok do
f_sch=f_sch+1 -- сколько файлов в сериале
        fname = HomeFolder('temp')..string.format("%05d",(i+startnum-1))..'.txt'
       SaveToFile({blok[i]},fname)
end


--Создаем и запускаем read.ps1 для работы в фоне с powershell.exe
script = HomeFolder('')..'read.ps1'
str0=''
for i = 1,f_sch do -- для каждого файла из сериала
str1=[[$audio_wav = "]]..HomeFolder('temp')..string.format("%05d",(i))..'.wav'..[["]]
str2=[[$txt_lst = "]]..HomeFolder('temp')..string.format("%05d",(i))..'_done.lst'..[["]]
str3=[[$lst_wav = "]]..HomeFolder('temp')..string.format("%05d",(i))..'_wav_done.lst'..[["]]
str4=[[While ($True) {
if (test-path $txt_lst) {
(New-Object Media.SoundPlayer $audio_wav).PlaySync()
New-Item $lst_wav 
break
}
else {
Start-Sleep -s 1
 }
} ]]
str0=str0..'\r\n'..str1..'\r\n'..str2..'\r\n'..str3..'\r\n'..str4..'\r\n'
end
SaveToFile({str0},script)

--получаем настройки голоса
vName, vRate, vPitch, vVolume = Voice()
str1=vName -- имя голоса
str2=vRate -- скорость голоса
str3=vPitch -- тембор голоса
str4=vVolume -- громкость голоса
str0=[[SetVoice("]]..vName..[[",]]..vRate..[[,]]..vPitch..[[,]]..vVolume..[[)]]..'\r\n'--строка настройки голоса
str0=str0..'\r\n'..[[a_buf = ]]..a_buf..'\r\n'--строка настройки голоса+строка размера БУФЕРА
str1=[[require "profiles/mylib_index" -- подгружаем личную библиотеку с функциями
o = {}
o.Reading_BlockSize=4800 -- чтение блоками 4800
o.Encoder_Param = ''  -- пустая строка параметров ==> отсутствие конвертации! WAV
o.Dictionary_Auto = false -- применять ли к тексту словари, активированные в Панели словарей
o.Notes_Auto = false--проверять ли текст на наличие примечаний
Settings(o)

local txt_start = 'start.lst'
local txt_end = 'end.lst'
win_mess="ЭТА КОПИЯ ДЕМАГОГА РАБОТАЕТ в ФОНОВОМ РЕЖИМЕ. ОКНО ЗАБЛОКИРОВАНО"
for i = 0,15 do
WNew((i),win_mess)
WActive((i),false) -- запрет редактирования 
end
Cancel()


--СРАЗУ приступаем к созданию аудио
a = AllFiles(HomeFolder('temp'),'*.txt')--подсчет текстовых файлов
a_cfg = AllFiles(HomeFolder('temp'),'*_done.lst')--подсчет .wav файлов
for i = 1,#a do
--Проверка на превышение лимита БУФЕРА
::CIRI::
StatusMessage('В БУФЕРЕ готовых аудиофайлов:: '..#a_cfg-1)
a_cfg = AllFiles(HomeFolder('temp'),'*_done.lst')
if #a_cfg > a_buf then
Cancel()
pause(1)
if FileExists(HomeFolder('temp')..txt_end) then goto HALT end
goto CIRI
end
WOpen(-1,HomeFolder('temp')..a[i])
if FileExists(HomeFolder('temp')..txt_end) then goto HALT end
-------------------------------------------------------------------------------------------------
other_dictionaries=true
FonemInOneFile=true
Use_Dictionaries(-1, -1, 2000)

WSave(-1,HomeFolder('temp')..a[i])--пересохраняем измененный словарями текст
WOpen(0,HomeFolder('temp')..a[i])--Переоткрываем измененный словарями текст
WAudio(0,false,false)
WNew(0,win_mess)
file = io.open(HomeFolder('temp')..string.format("%05d",(i))..'_done.lst',"w");file:close()--создаем пустой .lst файл - сообщение о завершении записи
pause(1)
if FileExists(HomeFolder('temp')..txt_end) then goto HALT end
end
goto END --цикл завершён штатно. Ничего лишнего не удаляем! Удаляем только файлы фоновых скриптов
::HALT::
a = AllFiles(HomeFolder('temp'),'*.*')
for i = 1,#a do
os.remove(HomeFolder('temp')..a[i])
end
::END::

--o = {}
--o.Notes_Auto = true
--o.Dictionary_Auto = true -- применять ли к тексту словари, активированные в Панели словарей
--Settings(o)


StatusMessage('Чтение остановлено')
os.remove(HomeFolder('')..'read.ps1')
os.remove(HomeFolder('')..'READ.lua')
os.remove(HomeFolder('')..'background_job.lua')
file = io.open(HomeFolder('temp')..'exit.lst',"w");file:close()-- сообщаем о завершении фоновых процессов
os.exit()
]]
SaveToFile({str0..str1},HomeFolder('')..'background_job.lua')--записываем рабочий скрипт для работы в фоне с Демагог2

--ЗАПУСК ФОНОВЫХ СКРИПТОВ ДВА В ОДНОМ: 2-АЯ КОПИЯ ДЕМАГОГА(запуск скрипта 'background_job.lua') + start powershell.exe 
exec_string = string.format([[start powershell.exe -windowStyle hidden  -executionpolicy bypass -file "]]..HomeFolder('')..[[read.ps1"]])--
os.execute(exec_string..' & start Demagog.exe /m /a "'..HomeFolder('')..'background_job.lua'..'"') -- несколько строк в одну

--ЗАВИСАНИЕ! Ждём когда от ДЕМАГОГ2 создат первый _done.lst файл
while FileExists(HomeFolder('temp')..string.format("%05d",(1))..'_done.lst')==false do -- ждём появления '_done.lst'
if FileExists(HomeFolder('temp')..txt_end)==true then goto HALT end
Cancel()
	if Cancel() then
	Gauge(0) -- remove progress bar (if was activated) 
		os.execute("TASKKILL /IM powershell.exe") -- убиваем powershell.exe
		SaveToFile({''},HomeFolder('temp')..txt_end)--даем команду СТОП для Демагог2.  Он за собой все удалит
		StatusMessage('Чтение Прервано!')
	end
pause(0.1)
StatusMessage("Заполняем БУФЕР аудиофайлами...")
end

--ЧТЕНИЕ:
for i = 2,#blok do -- выше уже выделили блок. Начинаем ждать разрешение на смену выделения блока:

--ЗАВИСАНИЕ! Ждем когда powershell.exe создаст первый _wav_done.lst - значит можно сменить выделеный блок
while FileExists(HomeFolder('temp')..string.format("%05d",(i-1))..'_wav_done.lst')==false do -- ждём появления '_wav_done.lst'
if FileExists(HomeFolder('temp')..txt_end)==true then goto HALT end
Cancel()
	if Cancel() then
	Gauge(0) -- remove progress bar (if was activated) 
		os.execute("TASKKILL /IM powershell.exe") -- убиваем powershell.exe
		SaveToFile({''},HomeFolder('temp')..txt_end)--даем команду СТОП для Демагог2.  Он за собой все удалит
		StatusMessage('Чтение Прервано!')
	end
pause(0.1)
a_cf = AllFiles(HomeFolder('temp'),'*_done.lst')--подсчёт "готовых" .wav файлов
--расчитать номер страницы

list_temp=string.sub(s,b0,#s)--текущая строка до конца книги
list_temp=math.ceil(#list_temp/sim_book)--текущая страница
list_s=math.ceil(#s/sim_book)--всего страниц
list_temp=list_s-list_temp+1--+1 что бы первая страница была не 0
--
u=round(((list_temp-1)*100)/list_s,1)
StatusMessage([[Остановить - Ctrl+P   Текущая страница: ]]..list_temp..[[ из ]]..list_s..[[ (]]..u..[[%)]]..[[;   в БУФЕРЕ аудиофайлов: ]]..#a_cf-1)
end

--Если цикл "ЗАВИСАНИЕ" разорван, значит файл _wav_done.lst появился и можно смело удалять все первые (i-1) файлы:
os.remove(HomeFolder('temp')..string.format("%05d",(i-1))..'_wav_done.lst')
os.remove(HomeFolder('temp')..string.format("%05d",(i-1))..'_done.lst')
os.remove(HomeFolder('temp')..string.format("%05d",(i-1))..'.txt')
os.remove(HomeFolder('temp')..string.format("%05d",(i-1))..'.wav')

if FileExists(HomeFolder('temp')..txt_end)==true then goto HALT end


--Возвращаем правильное выделение текста
b0=b0+#blok[i-1]
WSel(ind,b0,#s)--"ФИКТИВНОЕ" выделение текста до конца страницы для поднятия выделения текста к началу экрана
WSel(ind,b0,#blok[i])

--ЗАПОМИНАНИЕ ИСТОРИИ
--WOpen(-1,HomeFolder('profiles')..'read_history.txt')
--s_h = WText(-1)
--s_h = RexRepl(s_h,{[[>]]..namebook..[[>\d+>=]]})--удаляем историю
--s_h = s_h..'>'..namebook..'>'..b0..'>' -- записываем новую
--s_h = RexRepl(s_h,{[[[\r\n]+=\r]]})
--WNew(-1,s_h)
--WSave(-1,HomeFolder('profiles')..'read_history.txt')
end--for i = 1,#b do

end_read=true -- цикл штатно завершен, значит чтение дошло до конца книги можно из истории эту книгу удалять

::HALT::
while FileExists(HomeFolder('temp')..'exit.lst')==false do -- ждем сообщения от Демагог2 о завершении фоновых процессов
StatusMessage('Ждём завершения фоновых процессов...')
pause(1)
end
pause(1)--пауза в секундах на время завершения фоновых процессов
a = AllFiles(HomeFolder('temp'),'*.*')
for i = 1,#a do
os.remove(HomeFolder('temp')..a[i])
end
--ЗАПОМИНАНИЕ ИСТОРИИ 
WOpen(-1,HomeFolder('profiles')..'read_history.txt')
s_h = WText(-1)
s_h = RexRepl(s_h,{[[>]]..namebook..[[>\d+>=]]})--удаляем историю
if not end_read then --если это не конец книги, то сохраняем историю
s_h = s_h..'>'..namebook..'>'..b0..'>' -- записываем новую
end
s_h = RexRepl(s_h,{[[[\r\n]+=\r]]})
WNew(-1,s_h)
WSave(-1,HomeFolder('profiles')..'read_history.txt')



--Чистка по завершению цикла в результате окончания книги:
StatusMessage('Чтение остановлено')
os.remove(HomeFolder('')..'read.ps1')
os.remove(HomeFolder('')..'READ.lua')
os.remove(HomeFolder('')..'background_job.lua')


StatusMessage('Чтение остановлено')
WActive(ind)